// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from robot_controllers_msgs:msg/DiffDriveLimiterParams.idl
// generated code does not contain a copyright notice
#include "robot_controllers_msgs/msg/detail/diff_drive_limiter_params__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
robot_controllers_msgs__msg__DiffDriveLimiterParams__init(robot_controllers_msgs__msg__DiffDriveLimiterParams * msg)
{
  if (!msg) {
    return false;
  }
  // max_linear_velocity
  // max_linear_acceleration
  // max_angular_velocity
  // max_angular_acceleration
  // max_wheel_velocity
  // track_width
  // angular_velocity_limits_linear_velocity
  // scale_to_wheel_velocity_limits
  return true;
}

void
robot_controllers_msgs__msg__DiffDriveLimiterParams__fini(robot_controllers_msgs__msg__DiffDriveLimiterParams * msg)
{
  if (!msg) {
    return;
  }
  // max_linear_velocity
  // max_linear_acceleration
  // max_angular_velocity
  // max_angular_acceleration
  // max_wheel_velocity
  // track_width
  // angular_velocity_limits_linear_velocity
  // scale_to_wheel_velocity_limits
}

bool
robot_controllers_msgs__msg__DiffDriveLimiterParams__are_equal(const robot_controllers_msgs__msg__DiffDriveLimiterParams * lhs, const robot_controllers_msgs__msg__DiffDriveLimiterParams * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // max_linear_velocity
  if (lhs->max_linear_velocity != rhs->max_linear_velocity) {
    return false;
  }
  // max_linear_acceleration
  if (lhs->max_linear_acceleration != rhs->max_linear_acceleration) {
    return false;
  }
  // max_angular_velocity
  if (lhs->max_angular_velocity != rhs->max_angular_velocity) {
    return false;
  }
  // max_angular_acceleration
  if (lhs->max_angular_acceleration != rhs->max_angular_acceleration) {
    return false;
  }
  // max_wheel_velocity
  if (lhs->max_wheel_velocity != rhs->max_wheel_velocity) {
    return false;
  }
  // track_width
  if (lhs->track_width != rhs->track_width) {
    return false;
  }
  // angular_velocity_limits_linear_velocity
  if (lhs->angular_velocity_limits_linear_velocity != rhs->angular_velocity_limits_linear_velocity) {
    return false;
  }
  // scale_to_wheel_velocity_limits
  if (lhs->scale_to_wheel_velocity_limits != rhs->scale_to_wheel_velocity_limits) {
    return false;
  }
  return true;
}

bool
robot_controllers_msgs__msg__DiffDriveLimiterParams__copy(
  const robot_controllers_msgs__msg__DiffDriveLimiterParams * input,
  robot_controllers_msgs__msg__DiffDriveLimiterParams * output)
{
  if (!input || !output) {
    return false;
  }
  // max_linear_velocity
  output->max_linear_velocity = input->max_linear_velocity;
  // max_linear_acceleration
  output->max_linear_acceleration = input->max_linear_acceleration;
  // max_angular_velocity
  output->max_angular_velocity = input->max_angular_velocity;
  // max_angular_acceleration
  output->max_angular_acceleration = input->max_angular_acceleration;
  // max_wheel_velocity
  output->max_wheel_velocity = input->max_wheel_velocity;
  // track_width
  output->track_width = input->track_width;
  // angular_velocity_limits_linear_velocity
  output->angular_velocity_limits_linear_velocity = input->angular_velocity_limits_linear_velocity;
  // scale_to_wheel_velocity_limits
  output->scale_to_wheel_velocity_limits = input->scale_to_wheel_velocity_limits;
  return true;
}

robot_controllers_msgs__msg__DiffDriveLimiterParams *
robot_controllers_msgs__msg__DiffDriveLimiterParams__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  robot_controllers_msgs__msg__DiffDriveLimiterParams * msg = (robot_controllers_msgs__msg__DiffDriveLimiterParams *)allocator.allocate(sizeof(robot_controllers_msgs__msg__DiffDriveLimiterParams), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(robot_controllers_msgs__msg__DiffDriveLimiterParams));
  bool success = robot_controllers_msgs__msg__DiffDriveLimiterParams__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
robot_controllers_msgs__msg__DiffDriveLimiterParams__destroy(robot_controllers_msgs__msg__DiffDriveLimiterParams * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    robot_controllers_msgs__msg__DiffDriveLimiterParams__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence__init(robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  robot_controllers_msgs__msg__DiffDriveLimiterParams * data = NULL;

  if (size) {
    data = (robot_controllers_msgs__msg__DiffDriveLimiterParams *)allocator.zero_allocate(size, sizeof(robot_controllers_msgs__msg__DiffDriveLimiterParams), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = robot_controllers_msgs__msg__DiffDriveLimiterParams__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        robot_controllers_msgs__msg__DiffDriveLimiterParams__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence__fini(robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      robot_controllers_msgs__msg__DiffDriveLimiterParams__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence *
robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence * array = (robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence *)allocator.allocate(sizeof(robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence__destroy(robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence__are_equal(const robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence * lhs, const robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!robot_controllers_msgs__msg__DiffDriveLimiterParams__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence__copy(
  const robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence * input,
  robot_controllers_msgs__msg__DiffDriveLimiterParams__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(robot_controllers_msgs__msg__DiffDriveLimiterParams);
    robot_controllers_msgs__msg__DiffDriveLimiterParams * data =
      (robot_controllers_msgs__msg__DiffDriveLimiterParams *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!robot_controllers_msgs__msg__DiffDriveLimiterParams__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          robot_controllers_msgs__msg__DiffDriveLimiterParams__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!robot_controllers_msgs__msg__DiffDriveLimiterParams__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
